
	#define STRICT

      #include <windows.h>
      #include <math.h>
      #include <float.h>
      #pragma hdrstop

/*=================================================================================================================================*/

	#pragma argsused
      extern "C" void _stdcall __declspec(dllexport)
      InstantTrendLine (long NumBars, double* Output, double* Input,
                        double A, double B, double C, double D,
                        int CriticalDeltaPhase, int DeltaPhaseSumWindow)
      {
      double InternalA = 0.1 * A;
      double InternalB = 0.1 * B;
      double InternalC = 0.1 * C;
      double InternalD = 0.1 * D;
      double* DeltaPhase;
      double* Value1;
      double Value2;
      double Value3;
	double Value4;
      double Value5[2];
      double InPhase[2];
      double Quadrature[2];
      double Phase[2];
      double InstPeriod[2];
      double Period;
      double TrendLine;
      const int StartBar = 120;
      for (long i=StartBar; i<NumBars; i++)
      	{
            if (i==StartBar)
            	{
                  Value1 = (double*) new double [NumBars];
                  ZeroMemory(Value1,(NumBars*sizeof(double)));
                  DeltaPhase = (double*) new double [NumBars];
                  ZeroMemory(DeltaPhase,(NumBars*sizeof(double)));
                  ZeroMemory(Value5,(2*sizeof(double)));
                  ZeroMemory(InPhase,(2*sizeof(double)));
                  ZeroMemory(Quadrature,(2*sizeof(double)));
                  ZeroMemory(Phase,(2*sizeof(double)));
                  ZeroMemory(InstPeriod,(2*sizeof(double)));
                  }
            InPhase[1] = InPhase[0];
            Quadrature[1] = Quadrature[0];
            Phase[1] = Phase[0];
            InstPeriod[1] = InstPeriod[0];
            Value5[1] = Value5[0];
            Value1[i] = Input[i] - Input[i-6];
            Value2 = Value1[i-3];
            Value3 = ((1-InternalA)*(Value1[i]-Value1[i-6])) + InternalA*(Value1[i-2] - Value1[i-4]);
            InPhase[0] = (InternalB*Value2) + ((1-InternalB)*InPhase[1]);
            Quadrature[0] = (InternalC*Value3) + ((1-InternalC)*Quadrature[1]);
            if (fabs(InPhase[0]+InPhase[1]) > 0)
            	Phase[0] = atan(fabs((Quadrature[0]+Quadrature[1])/(InPhase[0]+InPhase[1])));
            if ((InPhase[0] < 0) && (Quadrature[0] > 0))   Phase[0] = 180 - Phase[0];
            if ((InPhase[0] < 0) && (Quadrature[0] < 0))   Phase[0] = 180 + Phase[0];
            if ((InPhase[0] > 0) && (Quadrature[0] < 0))   Phase[0] = 360 - Phase[0];
            DeltaPhase[i] = Phase[1] - Phase[0];
            if ((Phase[1] < 90) && (Phase[0] > 270))   DeltaPhase[i] = 360 + Phase[1] - Phase[0];
            if (DeltaPhase[i] < 1)   DeltaPhase[i] = 1;
            if (DeltaPhase[i] > CriticalDeltaPhase)  DeltaPhase[i] = CriticalDeltaPhase;
            InstPeriod[0] = 0;
            Value4 = 0;
            for (int e=0; e<=DeltaPhaseSumWindow; e++)
            	{
                  Value4 = Value4 + DeltaPhase[i-e];
                  if ((Value4 >360) && (InstPeriod[0]==0))  InstPeriod[0] = e;
                  }
            if (InstPeriod[0]==0)  InstPeriod[0] = InstPeriod[1];
            Value5[0] = (InternalD*InstPeriod[0]) + ((1-InternalD)*Value5[1]);
            Period = ceil(Value5[0]);
            TrendLine = 0;
            for (int e=0; e<(Period+2); e++)
            	{  TrendLine = TrendLine + Input[i-e];  }
            if (Period > 0)  TrendLine = TrendLine / (Period + 2);
            if (i < 200)  continue;
            Output[i] = TrendLine;
            if (i==(NumBars-1))
            	{
                  delete Value1;
                  delete DeltaPhase;
                  }
            }
      }

/*=================================================================================================================================*/

	#pragma argsused
      int _matherr (exception* E)
      {
      if (lstrcmp((E->name),"atan") == 0)
      	{
            if ((E->type) == OVERFLOW)   (E->retval) = DBL_MAX;
            if ((E->type) == UNDERFLOW)  (E->retval) = DBL_MIN;
            return 1;
            }
      return 0;
      }

/*=================================================================================================================================*/      


















































